#include <avr/interrupt.h>
#include <avr/io.h>

#include <util/delay.h>

#include <stdio.h>
#include <stdlib.h>

#define RED 1
#define GREEN 2
#define BLUE 3
#define OFF 0
#define NRM 5
#define NRD 16

unsigned int **models;
unsigned int ind;
unsigned int j;

/* intreruperea de comparatie cu OCR1A */
ISR(TIMER1_COMPA_vect)
{
	unsigned int i = 0;
	unsigned int x =0;
	PORTD &= ~(1 << PD0);
    PORTB &= ~(31 << PB0);
	DDRA = 0;
	DDRA = 0;
	
	for(i = 0; i < 7; i++){
		x = models[ind][j*8 + i];
		if(x == RED){
		}
		else if(x == GREEN){
		}
		else if(x == BLUE){
		}
	}
	
	j = (j + 1) % NRD;
}

/* intreruperea pentru pin change*/
ISR(PCINT3_vect)
{
    
    // PD1 apasat
    if((PIND & (1 << PD1)) == 0)
    {
			ind = (ind + 1) % NRM;
    }
	
}

/* initializeaza intrarile si iesirile */
void IO_init()
{
    // LED-ul RGB este pus ca iesire
	ind = 0;
    DDRD |= (1 << PD0);
    DDRB |= (31 << PB0);
	DDRA |= 255;
	DDRA |= 255;
    
    // butoanele sunt puse ca intrare, cu rezistenta de pull-up
    DDRD &= ~(1 << PD1);
    PORTD |= (1 << PD1);
    
    // intreruperile sunt activate pentru PCINT25 (PD1)
    PCICR  = (1 << PCIE3);
    PCMSK3 = (1 << PCINT25);
}

/* initializeaza timer-ul 1*/
void timer1_init()
{
    // pragul initial de comparare
    OCR1A = 156;
    
    // activeaza intreruperea de comparare cu OCR1A
    TIMSK1 = (1 << OCIE1A);
    
    // modul CTC cu OCR1A
    TCCR1B = (5 << CS10) | (1 << WGM12);
}

int main(void)
{

    // codul relevant laboratorului incepe aici
    sei();

    timer1_init();
    IO_init();
	
	while(1);

    return 0;
}



















